Attribute VB_Name = "GetFileIcon"
'==================================================
'Module: GetFileIcon2
'Purpose: Get shell icon for files/folders
'-------------------------------------------
'Author: Dipak Auddy
'E-mail: auddy@gawab.com
'Date: Mar 23, 2005
'-------------------------------------------
'You will need a PictureBox
'and following code in your form:
'
'With Picture1
'    .AutoRedraw = True
'    .BorderStyle = 0
'    .ScaleMode = vbUser
'    (for big icon change 16 to 32)
'    .Width = 16 * Screen.TwipsPerPixelX
'    .Height = 16 * Screen.TwipsPerPixelY
'End With
'Call GetSmallShellIcon(filePath, Picture1)
'Picture1.Image --> now contains the desired icon.
'==================================================
Option Explicit
'Shell Icon size...
Private Const SHGFI_BIGICON      As Long = &H0
Private Const SHGFI_SMALLICON    As Long = &H1
Private Const SHGFI_ICON         As Long = &H100
Private Const DI_NORMAL          As Long = 3
Private Type SHFILEINFO
    hIcon                            As Long           ' out: icon
    iIcon                            As Long           ' out: icon index
    dwAttributes                     As Long           ' out: SFGAO_ flags
    szDisplayName                    As String * 260 ' out: display name (or path)
    szTypeName                       As String * 80    ' out: type name
End Type
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, _
                                                  ByVal xLeft As Long, _
                                                  ByVal yTop As Long, _
                                                  ByVal hIcon As Long, _
                                                  ByVal cxWidth As Long, _
                                                  ByVal cyWidth As Long, _
                                                  ByVal istepIfAniCur As Long, _
                                                  ByVal hbrFlickerFreeDraw As Long, _
                                                  ByVal diFlags As Long) As Long
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, _
                                                                                 ByVal dwFileAttributes As Long, _
                                                                                 psfi As SHFILEINFO, _
                                                                                 ByVal cbFileInfo As Long, _
                                                                                 ByVal uFlags As Long) As Long

Public Sub GetBigShellIcon(FileName As String, _
                           DummyPicBox As PictureBox)

Dim sh_info  As SHFILEINFO

    SHGetFileInfo FileName, 0, sh_info, Len(sh_info), SHGFI_ICON Or SHGFI_BIGICON
    With DummyPicBox
        Set .Picture = Nothing
        DrawIconEx .hdc, 0, 0, sh_info.hIcon, 32, 32, 0, 0, DI_NORMAL
    End With 'DUMMYPICBOX

End Sub

Public Sub GetSmallShellIcon(FileName As String, _
                             DummyPicBox As PictureBox)

Dim sh_info  As SHFILEINFO

    SHGetFileInfo FileName, 0, sh_info, Len(sh_info), SHGFI_ICON Or SHGFI_SMALLICON
    With DummyPicBox
        Set .Picture = Nothing
        DrawIconEx .hdc, 0, 0, sh_info.hIcon, 16, 16, 0, 0, DI_NORMAL
    End With 'DUMMYPICBOX

End Sub

':)Code Fixer V2.2.0 (23/03/2005 5:40:59 AM) 32 + 27 = 59 Lines Thanks Ulli for inspiration and lots of code.
